/* ==UserStyle==
@name           Bitbucket Codemirror Monokai Theme
@namespace      github.com/openstyles/stylus
@version        1.0.0
@description    A Monokai color scheme for the Bitbucket CodeMirror file viewer
@author         Me
==/UserStyle== */

@-moz-document regexp(".*\\bbitbucket\\..*") {
  :root {
    --gutter-divider-color: #33333388;
    --gutter-text-color: #839496;

    --background-color: #222222;
    --line-highlight-background-color: #f8f8f211;

    --diff-added-color: #a6e22e22;
    --diff-removed-color: #f9267222;

    --general-text-color: #f8f8f2;
    --comment-text-color: #75715e;
    --string-text-color: #e6db74;
    --number-text-color: #be84ff;
    --constant-builtin-text-color: var(--number-text-color);
    --constant-userdef-text-color: var(--number-text-color);
    --variable-text-color: #ffffff;
    --keyword-text-color: #f92672;
    --storage-text-color: var(--keyword-text-color);
    --storage-type-text-color: #66d9ef;
    --class-name-text-color: #a6e22e;
    --inherited-class-name-text-color: var(--class-name-text-color);
    --function-name-text-color: #a6e22e;
    --function-argument-text-color: #fd971f;
    --tag-name-text-color: var(--keyword-text-color);
    --tag-attribute-text-color: var(--class-name-text-color);
    --library-function-text-color: #66d9ef;
    --library-constant-text-color: var(--library-function-text-color);
    --library-class-text-color: var(--library-function-text-color);
    --regexp-text-color: #f6aa11;
    --entity-text-color: #a6e22e;
  }

  table.diff-text {
    box-shadow: unset !important;
  }

  .CodeMirror-sizer {
    border-right: 0 !important;
    padding-right: 0 !important;
  }
  .CodeMirror-sizer + * {
    display: none !important;
  }

  .CodeMirror-vscrollbar {
    display: none !important;
  }

  .CodeMirror-scroll {
    height: auto !important;
    max-height: 100% !important;
    padding-bottom: 0 !important;
    overflow-x: auto !important;
    overflow-y: auto !important;
    max-width: 100% !important;
  }
  .comment-editor-wrapper .CodeMirror-scroll,
  .comment-editor-wrapper .CodeMirror-scroll .CodeMirror-sizer {
    height: 100% !important;
  }

  .CodeMirror-gutters {
    top: -50px !important;
  }

  .content-view > :not(.diff-editor) .CodeMirror-gutter-wrapper {
    top: -1px !important;
  }

  .diff-view,
  .diff-text,
  .CodeMirror-lines,
  .CodeMirror-gutters,
  .cm-m-markdown.cm-code-block,
  .code-block,
  .comment-content code,
  .context-expander {
    background-color: var(--background-color) !important;
    color: var(--general-text-color) !important;
    font-family: Fira Code, 'SFMono-Medium', 'SF Mono', 'Segoe UI Mono', 'Roboto Mono', 'Ubuntu Mono', Menlo, Consolas, Courier, monospace !important;
    font-size: 8pt;
    tab-size: 2 !important;
  }
  .diff-text .diff-line {
    tab-size: 2 !important;
  }

  .diff-text .additional-line-content {
    color: var(--aui-body-text);
  }

  .text-view .line,
  .line,
  .line .CodeMirror-gutter-elt > *,
  .CodeMirror-gutter-wrapper {
    background-color: transparent !important;
  }

  .context-expander {
    border-top-color: var(--line-highlight-background-color) !important;
    border-bottom-color: var(--line-highlight-background-color) !important;
  }

  .context-expander:hover td,
  .context-expander td .expand-context-button:hover {
    background-color: var(--line-highlight-background-color) !important;
  }

  .context-expander td .hidden-line-count,
  .context-expander td .expand-context-button {
    color: var(--comment-text-color) !important;
  }

  .bitbucket-theme kbd {
    background-color: var(--background-color) !important;
    border-color: var(--comment-text-color) !important;
    color: var(--general-text-color) !important;
  }

  .added.line,
  .added.line .bitbucket-gutter-marker,
  .added-line {
    background-color: var(--diff-added-color) !important;
    border-top-color: var(--diff-added-color) !important;
  }
  .added-line .ediff-change,
  .added.line .ediff-change,
  .ediff-add {
    background-color: var(--diff-added-color) !important;
    border-top-color: var(--diff-added-color) !important;
  }
  .removed.line,
  .removed.line .bitbucket-gutter-marker,
  .removed-line {
    background-color: var(--diff-removed-color) !important;
    border-top-color: var(--diff-removed-color) !important;
  }
  .removed-line .ediff-change,
  .removed.line .ediff-change,
  .ediff-delete {
    background-color: var(--diff-removed-color) !important;
    border-top-color: var(--diff-removed-color) !important;
  }
  .ediff-add, .ediff-delete, .ediff-change {
    border-radius: 0.25rem !important;
    padding: 2px !important;
  }
  .line .ediff-add, .line .ediff-delete, .line .ediff-change {
    padding: 0 !important;
  }

  .line:hover,
  .line:hover .CodeMirror-gutter-wrapper > .CodeMirror-gutter-elt > *,
  .line.modified:hover,
  .line.modified:hover .CodeMirror-gutter-wrapper > .CodeMirror-gutter-elt > *,
  .diff-segment .diff-row:hover .diff-gutter,
  .diff-segment .diff-row:hover .diff-line {
    background-color: var(--line-highlight-background-color) !important;
  }

  .line .line-number,
  .diff-gutter,
  .context-expander td.expand-button-cell,
  .unified-diff .gutter-border {
    border-right-color: var(--gutter-divider-color) !important;
  }
  .line .line-number,
  .diff-gutter .diff-line-number,
  .diff-view.text-view .line-number,
  .diff-view.text-view .line-number-marker {
    color: var(--gutter-text-color) !important;
  }
  .diff-gutter .diff-line-number:hover,
  .diff-view.text-view .CodeMirror-gutter-wrapper:hover .line-number,
  .diff-view.text-view .CodeMirror-gutter-wrapper:hover .line-number-marker {
    color: var(--general-text-color) !important;
  }

  .cm-qualifier,
  .hl-qualifier {
    color: var(--entity-text-color) !important;
  }

  .cm-builtin,
  .hl-builtin {
    color: var(--constant-builtin-text-color) !important;
  }

  .diff-empty-message,
  .diff-empty-whitespace-warning,
  .diff-empty-show-whitespace,
  .cm-comment,
  .hl-comment {
    color: var(--comment-text-color) !important;
  }

  .cm-keyword,
  .hl-keyword,
  .cm-operator,
  .hl-operator,
  .cm-meta,
  .hl-meta {
    color: var(--keyword-text-color) !important;
  }

  .cm-tag,
  .hl-tag {
    color: var(--tag-name-text-color) !important;
  }

  .cm-bracket,
  .hl-bracket,
  .cm-tag.cm-bracket,
  .hl-tag.hl-bracket {
    color: var(--general-text-color) !important;
  }
  .cm-attribute,
  .hl-attribute {
    color: var(--tag-attribute-text-color) !important;
  }

  .cm-def,
  .hl-def,
  .cm-variable,
  .hl-variable,
  .cm-variable-2,
  .hl-variable-2,
  .cm-variable-3,
  .hl-variable-3 {
    color: var(--variable-text-color) !important;
  }

  .cm-callee,
  .hl-callee {
    color: var(--library-function-text-color) !important;
  }

  .cm-number,
  .hl-number,
  .cm-atom,
  .hl-atom {
    color: var(--number-text-color) !important;
  }

  .cm-property,
  .hl-property {
    color: var(--library-function-text-color) !important;
  }

  .cm-type,
  .hl-type {
    color: var(--entity-text-color) !important;
  }

  .cm-string,
  .hl-string,
  .cm-string-2,
  .hl-string-2 {
    color: var(--string-text-color) !important;
  }
}
